VERSION 5.00
Begin VB.UserControl Dialog 
   BackColor       =   &H8000000E&
   ClientHeight    =   660
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   855
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   660
   ScaleWidth      =   855
End
Attribute VB_Name = "Dialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


Public Enum IconSize
  IconUser = -1
  Icon16 = 16
  Icon32 = 32
  Icon48 = 48
End Enum

Public Enum ColorConstants
  Standart = &H0
  Monochrome = &H1
  HighColor = &H2
  LowColor = &H80
End Enum

'// ---------------------------------------------------------------------------
'// Modul:      modUserIcons (07.08.2001) [Ver. 1.1]
'//             Icons in verschiedenen Gren aus einer Datei/Ressource laden.
'// Artikel:    http://www.vb-hellfire.de/knowlib/usericons.php
'//
'// Copyright:  2001 Thorsten Drfler (doerfler.t@vb-hellfire.de)
'//             http://www.vb-hellfire.de/
'// ---------------------------------------------------------------------------

Private Type GUID
  Data1    As Long
  Data2    As Integer
  Data3    As Integer
  Data4(8) As Byte
End Type

Private Type PICTDESC
  cbSize  As Long
  picType As Long
  hImage  As Long
  xExt    As Long
  yExt    As Long
End Type

Private Declare Function IIDFromString Lib "ole32" (ByVal lpsz As String, ByRef lpiid As GUID) As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32" (ByRef pPictDesc As PICTDESC, ByRef riid As GUID, ByVal fOwn As Long, ByRef ppvObj As IPicture) As Long

Private Const S_OK = 0
Private Const IPictureIID = "{7BF80981-BF32-101A-8BBB-00AA00300CAB}"

Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpszName As Any, ByVal uType As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal fuLoad As Long) As Long

Private Const LR_LOADFROMFILE = &H10
Private Const IMAGE_ICON = 1

  
Public Function LoadResIcon(ByVal ID As Variant, _
                   Optional ByVal Size As IconSize = Icon32, _
                   Optional ByVal iColor As ColorConstants, _
                   Optional ByVal Width As Long, _
                   Optional ByVal Height As Long) As StdPicture
                   
  Dim hIcon As Long
  
  If (Size <> IconUser) Then
    Height = Size
    Width = Size
  End If
  
  Select Case VarType(ID)
    Case vbLong, vbInteger
      hIcon = LoadImage(App.hInstance, CLng(ID), IMAGE_ICON, Width, Height, iColor)
    Case vbString
      hIcon = LoadImage(App.hInstance, CStr(ID), IMAGE_ICON, Width, Height, iColor)
  End Select
  
  Set LoadResIcon = HandleToPicture(hIcon, vbPicTypeIcon)
End Function

Public Function LoadIcon(ByVal FileName As String, _
                Optional ByVal Size As IconSize = Icon32, _
                Optional ByVal ColorDepth As ColorConstants, _
                Optional ByVal Width As Long, _
                Optional ByVal Height As Long) As StdPicture
  Dim hIcon As Long
             
  If (Size <> IconUser) Then
    Height = Size
    Width = Size
  End If
  
  hIcon = LoadImage(App.hInstance, FileName, IMAGE_ICON, Width, Height, LR_LOADFROMFILE Or ColorDepth)
  
  Set LoadIcon = HandleToPicture(hIcon, vbPicTypeIcon)
End Function

Public Function HandleToPicture(ByVal hImage As Long, _
                ByVal ImageType As PictureTypeConstants) As IPicture
  Dim tIID      As GUID
  Dim tPICTDEST As PICTDESC
  Dim lRet      As Long
  
  If (hImage = 0) Then Exit Function
  
  lRet = IIDFromString(StrConv(IPictureIID, vbUnicode), tIID)
  
  If (lRet = S_OK) Then
    With tPICTDEST
      .cbSize = Len(tPICTDEST)
      .picType = ImageType
      .hImage = hImage
    End With
    
    lRet = OleCreatePictureIndirect(tPICTDEST, tIID, True, HandleToPicture)
    
    If (lRet <> S_OK) Then Set HandleToPicture = Nothing
  End If
End Function


